﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="WebForm.aspx.cs" Inherits="Treeview.WebForm" %>

<%@ Register Assembly="Syncfusion.EJ.Web, Version=12.2450.0.36, Culture=neutral, PublicKeyToken=3d67ed1f87d44c89" Namespace="Syncfusion.JavaScript.Web" TagPrefix="ej" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <link href="http://cdn.syncfusion.com/js/web/flat-lime/ej.web.all-latest.min.css" rel="stylesheet" />
    <!--scripts-->
    <script src="http://code.jquery.com/jquery-1.10.2.min.js"></script>
    <script src="http://ajax.aspnetcdn.com/ajax/globalize/0.1.1/globalize.min.js"></script>
    <script src="http://cdnjs.cloudflare.com/ajax/libs/jquery-easing/1.3/jquery.easing.min.js"></script>
    <script src="http://cdn.syncfusion.com/js/web/ej.web.all-latest.min.js"></script>

</head>
<body>
    <form id="form1" runat="server">
        <h1>sample treeview with cut and paste option.</h1>
        <div>
            <ej:TreeView ID="TreeView1" runat="server" AllowKeyboardNavigation="true">
                <Nodes>
                    <ej:TreeViewNode Text="Node1">
                        <Nodes>
                            <ej:TreeViewNode Text="node2">
                                <Nodes>
                                    <ej:TreeViewNode Text="node2"></ej:TreeViewNode>
                                    <ej:TreeViewNode Text="node3"></ej:TreeViewNode>
                                    <ej:TreeViewNode Text="node4"></ej:TreeViewNode>
                                </Nodes>
                            </ej:TreeViewNode>
                            <ej:TreeViewNode Text="node3"></ej:TreeViewNode>
                            <ej:TreeViewNode Text="node4"></ej:TreeViewNode>
                        </Nodes>
                    </ej:TreeViewNode>
                    <ej:TreeViewNode Text="Node5">
                        <Nodes>
                            <ej:TreeViewNode Text="node6"></ej:TreeViewNode>
                            <ej:TreeViewNode Text="node7"></ej:TreeViewNode>
                            <ej:TreeViewNode Text="node8"></ej:TreeViewNode>
                        </Nodes>
                    </ej:TreeViewNode>
                    <ej:TreeViewNode Text="Node9">
                        <Nodes>
                            <ej:TreeViewNode Text="node10"></ej:TreeViewNode>
                            <ej:TreeViewNode Text="node11"></ej:TreeViewNode>
                            <ej:TreeViewNode Text="node12"></ej:TreeViewNode>
                        </Nodes>
                    </ej:TreeViewNode>
                </Nodes>
            </ej:TreeView>
            <br />
            <br />
           <ej:Menu ID="Menu1" MenuType="ContextMenu" ClientSideOnClick="OnClick" runat="server" ContextMenuTargetID="TreeView1">
        <Items>
            <ej:MenuItem Id="cut" Text="Cut"></ej:MenuItem>
        </Items>
        <Items>
            <ej:MenuItem Id="paste" Text="Paste"></ej:MenuItem>
        </Items>        
    </ej:Menu>
        </div>
    </form>
    <script>
        function cut()
        {
            var proxy = $("#TreeView1").ejTreeView("instance");
            var element = proxy.element.find("> ul");
            var selectedItem = proxy.getSelectedNode();
            var cutNodeLi;
            if ($(selectedItem).hasClass('first')) {
                cutNodeLi = $(selectedItem).removeClass('first').addClass('last');
                $(selectedItem).next().addClass('first');
            }
            else if (!$(selectedItem).hasClass('last'))
                cutNodeLi = $(selectedItem).addClass('last');
            else {
                cutNodeLi = $(selectedItem);
                $(selectedItem).prev().addClass('last');
            }
            proxy._cutCopyNodeText = cutNodeLi;
            proxy._removeNode();
            proxy.element.focus();
        }
        function paste()
        {

            var obj1 = $("#TreeView1").ejTreeView("instance");
            var element = obj1.element.find("> ul");
            var selectedItem = obj1.getSelectedNode();

            if (obj1._cutCopyNodeText != null) {
                $(selectedItem).length === 0 && (selectedItem = obj1.element);
                var addChildNode;
                var childNode = $(obj1._cutCopyNodeText).clone();
                if ($(childNode.find('a')[0]).hasClass('e-active'))
                    $(childNode.find('a')[0]).removeClass('e-active');
                if ($(childNode).hasClass('first'))
                    addChildNode = $(childNode).removeClass('first').addClass('last');
                else if (!$(childNode).hasClass('last'))
                    addChildNode = $(childNode).addClass('last');
                else
                    addChildNode = $(childNode);

                if (obj1.model.showCheckbox) {
                    var checkbox = ej.buildTag("input.nodecheckbox", "", {}, { type: "checkbox", name: "TreeView_Checkbox" });
                    checkbox.insertAfter(childNode.find(".e-chkbox-wrap"));
                    childNode.find(".e-chkbox-wrap").remove();
                    childNode.find(".nodecheckbox").ejCheckBox({ cssClass: obj1.model.cssClass, change: obj1._checkedChange });
                }
                // wire mouse over event 
                obj1._on(childNode.find(".e-text"), "mouseenter", obj1._mouseEnterEvent);
                obj1._on(childNode.find(".e-text"), "mouseleave", obj1._mouseLeaveEvent);

                if ($(selectedItem).children('div').children('span').hasClass('child'))
                    $(selectedItem).children('div').children('span').removeClass('child').addClass('expandimg');
                if ($(selectedItem).children('ul').length != 0) {
                    $(selectedItem).children('ul').find('>li').last().removeClass('last');
                    $(selectedItem).find('>ul').append($(addChildNode));
                }
                else {
                    var wrapUl = ej.buildTag('ul.e-treeview-ul');
                    node = $(wrapUl).append($(addChildNode));
                    $(selectedItem).append($(node));
                    $(selectedItem).children('div').find('>div').first().addClass('e-icon e-minus');
                }
                var liCollection = $(selectedItem).parents('li.e-item');
                liCollection.each(function (index) {
                    var licoll = $(liCollection[index]).children('ul').find('>li');
                    if (licoll.length == 1) {
                        $(licoll).addClass('last');
                    }
                });
                obj1._cutCopyNodeText = null;
            }
        }
        function OnClick(sender, args) {
            if (sender.events.ID=="cut") {
               cut()
            }

            else if (sender.events.ID == "paste") {
                paste()
            }
        }
    </script>
</body>
</html>
